<?php
namespace Geral\Repositories;

class Lote extends \Doctrine\ORM\EntityRepository
{
	public function insereProdutoLote($cdfilial, $nrloteestq, $nrsublote, $cdproduto, $dtvalilote, $dtfabrprod ){
		$sql = <<<SQL
        INSERT INTO LOTE
		(CDFILIAL, NRLOTEESTQ, NRSUBLOTE, CDPRODUTO, IDSTATLOTE, DTENTRLOTE, DTVALILOTE,DTFABRPROD)
		(SELECT :P_CDFILIAL CDFILIAL, :P_NRLOTEESTQ NRLOTEESTQ, :P_NRSUBLOTE NRSUBLOTE,
		        :P_CDPRODUTO CDPRODUTO,
		        'L' IDSTATLOTE, SYSDATE DTENTRLOTE,
		        :P_DTVALILOTE DTVALILOTE, :P_DTFABRPROD DTFABRPROD
		 FROM PARAMGERAL
		 MINUS
		 SELECT CDFILIAL,      NRLOTEESTQ,  NRSUBLOTE,
		        CDPRODUTO, 'L', SYSDATE, :P_DTVALILOTE DTVALILOTE, :P_DTFABRPROD DTFABRPROD
		 FROM LOTE
		 WHERE  :P_CDFILIAL   =  CDFILIAL     AND
		        :P_NRLOTEESTQ =  NRLOTEESTQ   AND
		        :P_NRSUBLOTE  =  NRSUBLOTE    AND
		        :P_CDPRODUTO  =  CDPRODUTO)                 

SQL;
		$params = array(
				"P_CDFILIAL" => $cdfilial,
				"P_NRLOTEESTQ" => $nrloteestq,
				"P_NRSUBLOTE" => $nrsublote,
				"P_CDPRODUTO" => $cdproduto,
		        "P_DTVALILOTE" => $dtvalilote,
		        "P_DTFABRPROD" => $dtfabrprod
		
		);
		
		try {
			return $this->getEntityManager()->getConnection()->executeQuery($sql, $params);
		} catch (\Exception $e) {
			throw $e;
		}		
	}
	
	public function updataLote($cdfilial, $nrloteestq, $nrsublote, $cdproduto, $dtvalilote, $dtfabrprod, $nrloteforn){
	    
	    $sql = <<<SQL
        UPDATE LOTE
	    SET   DTVALILOTE = :P_DTVALILOTE,
	          DTFABRPROD = :P_DTFABRPROD, 
	          NRLOTEFORN = :P_NRLOTEFORN
	    WHERE
	    (CDFILIAL   = :P_CDFILIAL)     AND
	    (CDPRODUTO  = :P_CDPRODUTO)    AND
	    (NRLOTEESTQ = :P_NRLOTEESTQ)   AND
	    (NRSUBLOTE  = :P_NRSUBLOTE)
	    
SQL;
	    $params = array(
	        "P_CDFILIAL" => $cdfilial,
	        "P_NRLOTEESTQ" => $nrloteestq,
	        "P_NRSUBLOTE" => $nrsublote,
	        "P_CDPRODUTO" => $cdproduto,
	        "P_DTVALILOTE" => $dtvalilote,
	        "P_DTFABRPROD" => $dtfabrprod,
	        "P_NRLOTEFORN" => $nrloteforn,	    
	    );
	    
	    try {
	        return $this->getEntityManager()->getConnection()->executeQuery($sql, $params);
	    } catch (\Exception $e) {
	        throw $e;
	    }   
	    
	}

}